clear all;
clc;
% Parameterek
N = 66;
r = 0.83;
 
%% 1. feladat - bzisok generlsa

t = 0:N-1;
% inicializls
bazis  = zeros(N,N-2);
recBazis = zeros(N-2,N);

%Bzisok generlsa
for k = 1:(N/2)-1
    bazis(:,(2*k-1)) = real(exp(j*k*(2*pi/N)*t)); % cos
    bazis(:,(2*k))   = imag(exp(j*k*(2*pi/N)*t)); % sin

    recBazis((2*k-1),:) = real(2*exp(-j*k*(2*pi/N)*t));  % cos
    recBazis((2*k),:)   = -imag(2*exp(-j*k*(2*pi/N)*t));  % sin
end

% egyenkomponens s a maximlis frekvencihoz tartoz komponens hozzadsa
bazis=[ones(N,1) bazis cos(t*pi)'];
recBazis=[ones(1,N); recBazis; cos(t*pi);];

% reciprok bzis normlsa
recBazis = recBazis/N;

% ellenrzs
m = eye(N)-(recBazis*bazis);
if max(max(abs(m))) > 10^-10
    'Hiba'
else
    'Helyes bzisok'
end

% bzis matrix ortogonalitasa
if (bazis'*bazis)-diag(diag(bazis'*bazis)) > 10^-15
    'Hiba'
else
    'Bzis ortogonlis'
end

% reciprok bzis matrix ortogonalitasa
if (recBazis*recBazis')-diag(diag(recBazis*recBazis')) > 10^-15
    'Hiba'
else
    'Reciprok bzis ortogonlis'
end

%% 2.1 - Ngyszgjel
t=0:N-1;
negyszog_alap = square(t*2*pi/(N/2)) + 0.5;
negyszog_suly = inv(bazis)*negyszog_alap';
negyszog_teszt = bazis*negyszog_suly;
figure(2);
stem(negyszog_alap, 'or');
hold on;
stem(negyszog_teszt, 'xb');
 
%% 2.2 - Hromszgjel
t=0:N-1;
haromszog_alap = sawtooth(t*2*pi/(N/2), 0.5) + 0.5;
haromszog_suly = inv(bazis)*haromszog_alap';
haromszog_teszt = bazis*haromszog_suly;
figure(3);
stem(haromszog_alap, 'or');
hold on;
stem(haromszog_teszt, 'xb');
 
%% 2.3 - Multiszinus jel
db=0:1:N-1;
db=db/N;
multisin_alap=sin(2*pi*db)+0.5;
rand_phase = 2*pi*rand(N/2-1,1);
for i=2:N/2
    multisin_alap = multisin_alap+sin(i*2*pi*db+rand_phase(i-1));
end
multisin_alap = multisin_alap';
multisin_suly = inv(bazis)*multisin_alap;
multisin_teszt = bazis*multisin_suly;
figure(4);
stem(multisin_alap, 'or');
hold on;
stem(multisin_teszt, 'xb');

%% 3. feladat
% inicializls
negyszog_suly_becslo = zeros(N,1);
haromszog_suly_becslo  = zeros(N,1);
multisin_suly_becslo = zeros(N,1);

% becslk szmtsa
for i= 1:N
    negyszog_suly_becslo   = negyszog_suly_becslo   + recBazis(:,i)*negyszog_alap(i);
    haromszog_suly_becslo  = haromszog_suly_becslo  + recBazis(:,i)*haromszog_alap(i);
    multisin_suly_becslo = multisin_suly_becslo + recBazis(:,i)*multisin_alap(i);
end

%% 4. feladat

% tartomnyok duplra bvtse
negyszog_alap = [negyszog_alap negyszog_alap];
B2 = [bazis; bazis]';
rB2 = [recBazis recBazis];

% analiztor vltozk inicializlsa
y = zeros(size(negyszog_alap));
x_becslo = zeros(N,length(negyszog_alap));

% Ngyszg analiztor
for i = 1:1:length(negyszog_alap)
    y(i)= x_becslo(:,i)' * B2(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (negyszog_alap(i)-y(i)) * rB2(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
hibajel = [negyszog_alap(1:end)-y(1:end)];
figure(4)
subplot(3,1,1); plot(negyszog_alap); title('y');
subplot(3,1,2); plot(y); title('y becsl');
subplot(3,1,3); plot(hibajel); title('hibajel');

% Hromszg analiztor
haromszog_alap = [haromszog_alap haromszog_alap];
y = zeros(size(haromszog_alap));
x_becslo = zeros(N,length(haromszog_alap));
for i = 1:1:length(haromszog_alap)
    y(i)= x_becslo(:,i)' * B2(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (haromszog_alap(i)-y(i)) * rB2(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
hibajel = [haromszog_alap(1:end)-y(1:end)];
figure(5)
subplot(3,1,1); plot(haromszog_alap); title('y');
subplot(3,1,2); plot(y); title('y becsl');
subplot(3,1,3); plot(hibajel); title('hibajel');
hold off


%% 5. A feladat

% hlzat inicializlsa
num = [0 (1-r) 0];
den = [1 0 r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% bzisok kiterjesztse
bazis = [bazis; bazis; bazis; bazis]';
recBazis = [recBazis recBazis recBazis recBazis];

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (20)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off

%% 5. B feladat

% hlzat inicializlsa
num = [0 (1-r) 0];
den = [1 0 -r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (21)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off
    
%% 5. C feladat

% hlzat inicializlsa
num = [(1-r) 0 0];
den = [1 0 0 r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (22)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off

%% 5. D feladat

% hlzat inicializlsa
num = [(1-r) 0 0];
den = [1 0 0 -r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (23)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off

%% 5. E feladat

% hlzat inicializlsa
num = [(1-r) 0 0 0];
den = [1 0 0 0 r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (24)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off    

%% 5. F feladat

% hlzat inicializlsa
num = [(1-r) 0 0 0];
den = [1 0 0 0 -r];

% a jel tvezetse a szrn
rendszer = filter(num, den, multisin_alap);

% analiztor
y = zeros(size(rendszer));
x_becslo = zeros(N,length(rendszer));
for i = 1:1:length(rendszer)
    y(i)= x_becslo(:,i)' * bazis(:, mod(i-1,N) + 1);
    x_becslo(:,i+1)= (rendszer(i)-y(i)) * recBazis(:,mod(i-1,N) + 1)+ x_becslo(:,i);
end
% egyenkomponens, koszinuszos s szinuszos tagok sszefslse
h_becslo_x = [x_becslo(1,N) ; (x_becslo(2:2:end-1,N)-j*x_becslo(3:2:end,N))];
multisin_suly_x = [multisin_suly(1:1) ; (multisin_suly(2:2:end-1,1)-j*multisin_suly(3:2:end,1))];
mert_kar = h_becslo_x./multisin_suly_x;

% amplitudo maximuma
max(abs(multisin_alap)) 

% szmtott karakterisztika ltrehozsa
[h, w] = freqz(num, den, floor((N+1)/2));
ampl = abs(h);
pha = phase(h);

% eredmnyek kirajzolsa
figure (25)
    subplot (2,1,1)
    plot (0:2/(N-1):1, ampl);
    hold on
    stem (0:2/(N-1):1, abs(mert_kar));
        title('amplitd menet');
        xlabel('normalizlt frekvencia');
        ylabel('amplitd');
        legend('szmtott', 'mrt');
    hold off
    subplot (2,1,2)
    plot (0:2/(N-1):1, pha*180/pi);
    hold on
    stem (0:2/(N-1):1, phase(mert_kar)*180/pi);
        title('fzis menet');
        xlabel('normalizlt frekvencia');
        ylabel('fzis []');
        legend('szmtott', 'mrt');
    hold off    

%% 1. feladat - bzisok generlsa

t = 0:N-1;
% inicializls
bazis  = zeros(N,N-2);
recBazis = zeros(N-2,N);

%Bzisok generlsa
for k = 1:(N/2)-1
    bazis(:,(2*k-1)) = real(exp(j*k*(2*pi/N)*t)); % cos
    bazis(:,(2*k))   = imag(exp(j*k*(2*pi/N)*t)); % sin

    recBazis((2*k-1),:) = real(2*exp(-j*k*(2*pi/N)*t));  % cos
    recBazis((2*k),:)   = -imag(2*exp(-j*k*(2*pi/N)*t));  % sin
end

% egyenkomponens s a maximlis frekvencihoz tartoz komponens hozzadsa
bazis=[ones(N,1) bazis cos(t*pi)'];
recBazis=[ones(1,N); recBazis; cos(t*pi);];

% reciprok bzis normlsa
recBazis = recBazis/N;

% ellenrzs
m = eye(N)-(recBazis*bazis);
if max(max(abs(m))) > 10^-10
    'Hiba'
else
    'Helyes bzisok'
end

% bzis matrix ortogonalitasa
if (bazis'*bazis)-diag(diag(bazis'*bazis)) > 10^-15
    'Hiba'
else
    'Bzis ortogonlis'
end

% reciprok bzis matrix ortogonalitasa
if (recBazis*recBazis')-diag(diag(recBazis*recBazis')) > 10^-15
    'Hiba'
else
    'Reciprok bzis ortogonlis'
end    
    
%% 6. feladat
t=0:N-1;
negyszog_alap = square(t*2*pi/(N/2)) + 0.5;
haromszog_alap = sawtooth(t*2*pi/(N/2), 0.5) + 0.5;

% kt peridus sszeraksa
y = [negyszog_alap negyszog_alap; haromszog_alap haromszog_alap];

% derivltak:
y_d = zeros(2,2*N);
for i = 1:2;
    for k = 2:2*N
        y_d(i,k) = y(i,k) - y(i,k-1);
    end
end
 
%Alapjelek s derivltjaik
for i = 1:2;
    figure;
    stem(y(i,:), 'k' );hold on;
    stem(y_d(i,:), 'r');
end

% bzisok kiterjesztse
rB2 = [recBazis recBazis];
B2  = [bazis; bazis];

% egytthatk inicializlsa
negyszog_eh_becslo = zeros(N,1); 
haromszog_eh_becslo = zeros(N,1);
for n=1:(2*N)
    % negyszogjel
    y_negyszog(n) = B2(n,:)*negyszog_eh_becslo(:,n);
    negyszog_eh_becslo(:,n+1) = negyszog_eh_becslo(:,n) + rB2(:,n)*(y_d(1,n));
    % haromszogjel
    y_haromszog(n) = B2(n,:)*haromszog_eh_becslo(:,n);
    haromszog_eh_becslo(:,n+1) = haromszog_eh_becslo(:,n) + rB2(:,n)*(y_d(2,n));
end

y_d_kalap = [y_negyszog;y_haromszog];

% szmtott s mrt jelek sszehasonltsa
for i = 1:2;
    figure;
    stem(y_d(i,:), 'r');
    hold on;
    stem(y_d_kalap(i,:), 'b');
end

